#include "Array.hh"

#include <exception>
#include <iostream>
using namespace std;

Array::Array(int size)
	: size_(size),
	  data_(new int[size])
{}

Array::Array(const Array& other) 
	: size_(other.size_),
	  data_(new int[size_])
{
	cout << "Array::Array(const Array& other) called..." << endl;
	for(int i=0;i<size_;i++) {
		data_[i]=other.data_[i];
	}
}

Array& Array::operator=(const Array& other) {
	cout << "Array& Array::operator=(const Array& other) called..." << endl;
	if(this!=&other) {
		delete [] data_;
		size_=other.size_;
		data_=new int[size_];
		for(int i=0;i<size_;i++) {
			data_[i]=other.data_[i];
		}	
	}
	return *this;
}

Array::~Array(void) {
	delete [] data_;
}



int& Array::operator[](int index) {
	if(index<0 || index>=size_) {
		throw std::exception();
	}
	return data_[index];
}

int Array::size() const {
	return size_;
}
